Attribute VB_Name = "Startup"
Option Explicit



Private Function GetDatabasePath() As String
Dim lReturn As Long
Dim sClass As String
Dim lDisposition As Long
Dim Security As SECURITY_ATTRIBUTES
Dim sDatabasePath As String
Dim hWndQue As Long
Dim lLength As Long
  
  'Create or Open Que Registry entry for local machine
  sClass = Space$(255)
  lReturn = RegCreateKeyEx(HKEY_LOCAL_MACHINE, "QUE", 0&, sClass, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, Security, hWndQue, lDisposition)
  If lReturn <> ERROR_SUCCESS Then
    gAPIDisplayError lReturn
  End If
  
  lLength = 255
  sDatabasePath = Space$(lLength)
  lReturn = RegQueryValueEx(hWndQue, "DatabasePath", 0&, REG_SZ, sDatabasePath, lLength)
  If lReturn <> ERROR_SUCCESS Then
    GetDatabasePath = App.Path
  Else
    GetDatabasePath = Left$(sDatabasePath, lLength - 1)
  End If
  
  'Close open keys
  lReturn = RegCloseKey(hWndQue)

End Function

Private Sub SaveDatabasePath(sDatabasePath As String)
Dim lReturn As Long
Dim hWndQue As Long
Dim sClass As String
Dim Security As SECURITY_ATTRIBUTES
Dim lDisposition As Long

  'Create or Open Que Registry entry for local machine
  sClass = Space$(255)
  lReturn = RegCreateKeyEx(HKEY_LOCAL_MACHINE, "QUE", 0&, sClass, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, Security, hWndQue, lDisposition)
  If lReturn <> ERROR_SUCCESS Then
    gAPIDisplayError lReturn
  End If

  'Save Database path in the registry
  lReturn = RegSetValueEx(hWndQue, "DatabasePath", 0&, REG_SZ, sDatabasePath, Len(sDatabasePath))
  If lReturn <> ERROR_SUCCESS Then
    gAPIDisplayError lReturn
  End If

  'Close open keys
  lReturn = RegCloseKey(hWndQue)

End Sub

Sub Main()

  Load frmDataLocation

  frmDataLocation!txtPath.TEXT = GetDatabasePath
  
  frmDataLocation.Show vbModal
  
  If frmDataLocation!chkPressed.VALUE Then
    Call SaveDatabasePath(Trim$(frmDataLocation!txtPath.TEXT))
  End If
  
  End

End Sub


